<?php

namespace Drupal\maestro\Entity;

use Drupal\views\EntityViewsData;
use Drupal\views\EntityViewsDataInterface;

/**
 * Provides Views data for the Maestro Queue Entity.
 */
class MaestroQueueViewsData extends EntityViewsData implements EntityViewsDataInterface {

  /**
   * {@inheritdoc}
   */
  public function getViewsData() {
    $data = parent::getViewsData();

    $data['maestro_queue']['table']['base'] = [
      'field' => 'id',
      'title' => $this->t('Maestro Queue'),
      'help' => $this->t('The Maestro Queue entity ID.'),
    ];

     // Relationship to the Maestro Process entity
    $data['maestro_queue']['process_id'] = [
      'title' => t('Maestro Process'),
      'help' => t('Relate this queue entity to its associated process.'),
      'relationship' => [
        'base' => 'maestro_process',
        'base field' => 'process_id',
        'field' => 'process_id',
        'id' => 'standard',
        'label' => t('Maestro Process Entity'),
      ],
    ];
    return $data;
  }

}
